|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
public interface Registry
This is the "Full" Registry interface. It contains not only the get/put behavior from CoreRegistry, but also APIs which control tags/comments/ratings/versions/etc.
| Method Summary | |
|---|---|
boolean |
addAspect(String name,
Aspect aspect)
Add aspect by passing a name and the aspect object. |
void |
addAssociation(String sourcePath,
String targetPath,
String associationType)
Adds an association stating that the resource at "associationPath" associate on the resource at "associationPath". |
String |
addComment(String resourcePath,
Comment comment)
Adds a comment to a resource. |
void |
applyTag(String resourcePath,
String tag)
Applies the given tag to the resource in the given path. |
void |
associateAspect(String resourcePath,
String aspect)
Associate an Aspect with a resource. |
void |
beginTransaction()
Start a new transaction |
void |
commitTransaction()
Commit the currently active transaction |
String |
copy(String sourcePath,
String targetPath)
Copy a resource in the registry. |
void |
createLink(String path,
String target)
Create a symbolic link or mount a registry |
void |
createLink(String path,
String target,
String subTargetPath)
Create a symbolic link or mount a registry |
void |
createVersion(String path)
Creates a new version of the resource. |
void |
dump(String path,
Writer writer)
Check out the given path as an xml. |
void |
editComment(String commentPath,
String text)
Change the text of an existing comment. |
Collection |
executeQuery(String path,
Map parameters)
Executes a custom query which lives at the given path in the Registry. |
Association[] |
getAllAssociations(String resourcePath)
Get all associations of the given resource. |
String[] |
getAspectActions(String resourcePath,
String aspectName)
Obtain a list of the available actions on a given resource for a given Aspect. |
Association[] |
getAssociations(String resourcePath,
String associationType)
Get all associations of the given resource for a give association type. |
String[] |
getAvailableAspects()
Get a list of the available Aspects for this Registry |
float |
getAverageRating(String resourcePath)
Returns the average rating for the given resource. |
Comment[] |
getComments(String resourcePath)
Get all comments for the given resource. |
String |
getEventingServiceURL(String path)
Gets the URL of the WS-Eventing Service. |
LogEntryCollection |
getLogCollection(String resourcePath,
int action,
String userName,
Date from,
Date to,
boolean recentFirst)
Returns the logs of the activities occurred in the registry. |
LogEntry[] |
getLogs(String resourcePath,
int action,
String userName,
Date from,
Date to,
boolean recentFirst)
Returns the logs of the activities occurred in the registry. |
Resource |
getMetaData(String path)
Returns the meta data of the resource at a given path. |
int |
getRating(String path,
String userName)
Returns the rating given to the specified resource by the given user |
RegistryContext |
getRegistryContext()
Get the configuration for this Registry |
TaggedResourcePath[] |
getResourcePathsWithTag(String tag)
Returns the paths of all Resources that are tagged with the given tag. |
Tag[] |
getTags(String resourcePath)
Returns all tags used for tagging the given resource. |
String[] |
getVersions(String path)
Get a list of all versions of the resource located at the given path. |
String |
importResource(String suggestedPath,
String sourceURL,
Resource resource)
Creates a resource by fetching the resource content from the given URL. |
void |
invokeAspect(String resourcePath,
String aspectName,
String action)
This invokes an action on a specified Aspect, which must be associated with the Resource at the given path. |
String |
move(String currentPath,
String newPath)
Move a resource in the registry. |
void |
rateResource(String resourcePath,
int rating)
Rate the given resource. |
boolean |
removeAspect(String aspect)
Remove the given aspect from registry context. |
void |
removeAssociation(String sourcePath,
String targetPath,
String associationType)
To remove an association for a given resource |
void |
removeComment(String commentPath)
Delete an existing comment. |
void |
removeLink(String path)
Remove a symbolic link or mount point created |
void |
removeTag(String path,
String tag)
Removes a tag on a resource. |
String |
rename(String currentPath,
String newName)
Rename a resource in the registry. |
void |
restore(String path,
Reader reader)
Check in the input axiom element into database. |
void |
restoreVersion(String versionPath)
Reverts a resource to a given version. |
void |
rollbackTransaction()
Rollback the currently active transaction |
Collection |
searchContent(String keywords)
Search the content of resources |
void |
setEventingServiceURL(String path,
String eventingServiceURL)
Sets the URL of the WS-Eventing Service. |
| Methods inherited from interface org.wso2.carbon.registry.core.CoreRegistry |
|---|
delete, get, get, newCollection, newResource, put, resourceExists |
| Method Detail |
|---|
Resource getMetaData(String path)
throws RegistryException
path - Path of the resource. e.g. /project1/server/deployment.xml
RegistryException - is thrown if the resource is not in the registry
String importResource(String suggestedPath,
String sourceURL,
Resource resource)
throws RegistryException
suggestedPath - path where we'd like to add the new resource. Although this path is
specified by the caller of the method, resource may not be actually
added at this path.sourceURL - where to fetch the resource contentresource - a template Resource
RegistryException - if we couldn't get or store the new resource
String rename(String currentPath,
String newName)
throws RegistryException
currentPath - current path of the resourcenewName - the name of the new resource
RegistryException - if something went wrong
String move(String currentPath,
String newPath)
throws RegistryException
currentPath - current path of the resourcenewPath - where we'd like to move the resource
RegistryException - if something went wrong
String copy(String sourcePath,
String targetPath)
throws RegistryException
sourcePath - current path of the resourcetargetPath - where we'd like to copy the resource
RegistryException - if something went wrong
void createVersion(String path)
throws RegistryException
path - the resource path.
RegistryException - if something went wrong.
String[] getVersions(String path)
throws RegistryException
path - path of a current version of a resource
RegistryException - if there is an error
void restoreVersion(String versionPath)
throws RegistryException
versionPath - path of the version to be reverted. It is not necessary to provide the
path of the resource as it can be derived from the version path.
RegistryException - if there is an error
void addAssociation(String sourcePath,
String targetPath,
String associationType)
throws RegistryException
sourcePath - Path of the source resourcetargetPath - Path of the target resourceassociationType - Type of the association
RegistryException - Depends on the implementation
void removeAssociation(String sourcePath,
String targetPath,
String associationType)
throws RegistryException
sourcePath - Path of the source resourcetargetPath - Path of the target resourceassociationType - Type of the association
RegistryException - Depends on the implementation
Association[] getAllAssociations(String resourcePath)
throws RegistryException
resourcePath - Path of the resource to analyse associations.
RegistryException - If something went wrong
Association[] getAssociations(String resourcePath,
String associationType)
throws RegistryException
resourcePath - Path of the resource to analyse associations.associationType - Type of the association , that could be dependency, or some other
type.
RegistryException - If something went wrong
void applyTag(String resourcePath,
String tag)
throws RegistryException
resourcePath - Path of the resource to be tagged.tag - Tag. Any string can be used for the tag.
RegistryException - is thrown if a resource does not exist in the given path.
TaggedResourcePath[] getResourcePathsWithTag(String tag)
throws RegistryException
tag - the tag to search for
RegistryException - if an error occurs
Tag[] getTags(String resourcePath)
throws RegistryException
resourcePath - Path of the resource
RegistryException - is thrown if a resource does not exist in the given path.
void removeTag(String path,
String tag)
throws RegistryException
path - Resource path tagged with the given tag.tag - Name of the tag to be removed.
RegistryException - if there's a problem
String addComment(String resourcePath,
Comment comment)
throws RegistryException
resourcePath - Path of the resource to add the comment.comment - Comment instance for the new comment.
RegistryException - is thrown if a resource does not exist in the given path.
void editComment(String commentPath,
String text)
throws RegistryException
commentPath - path to comment resource ("..foo/r1;comment:1")text - new text for the comment.
RegistryException - Registry implementations may handle exceptions and throw
RegistryException if the exception has to be propagated to the
client.
void removeComment(String commentPath)
throws RegistryException
commentPath - path to comment resource ("..foo/r1;comment:1")
RegistryException - Registry implementations may handle exceptions and throw
RegistryException if the exception has to be propagated to the
client.
Comment[] getComments(String resourcePath)
throws RegistryException
resourcePath - path of the resource.
RegistryException - Registry implementations may handle exceptions and throw
RegistryException if the exception has to be propagated to the
client.
void rateResource(String resourcePath,
int rating)
throws RegistryException
resourcePath - Path of the resource.rating - Rating value between 1 and 5.
RegistryException - Registry implementations may handle exceptions and throw
RegistryException if the exception has to be propagated to the
client.
float getAverageRating(String resourcePath)
throws RegistryException
resourcePath - Path of the resource.
RegistryException - if an error occurs
int getRating(String path,
String userName)
throws RegistryException
path - Path of the resourceuserName - username of the user
RegistryException - if there is a problem
Collection executeQuery(String path,
Map parameters)
throws RegistryException
path - Path of the query to execute.parameters - a Map of query parameters (name -> value)
RegistryException - depends on the implementation.
LogEntry[] getLogs(String resourcePath,
int action,
String userName,
Date from,
Date to,
boolean recentFirst)
throws RegistryException
resourcePath - If given, only the logs related to the resource path will be returned. If
null, logs for all resources will be returned.action - Only the logs pertaining to this action will be returned. For acceptable
values, see LogEntry.userName - If given, only the logs for activities done by the given user will be
returned. If null, logs for all users will be returned.from - If given, logs for activities occurred after the given date will be
returned. If null, there will not be a bound for the starting date.to - If given, logs for activities occurred before the given date will be
returned. If null, there will not be a bound for the ending date.recentFirst - If true, returned activities will be most-recent first. If false,
returned activities will be oldest first.
RegistryException - if there is a problemAccepted values for action parameter
LogEntryCollection getLogCollection(String resourcePath,
int action,
String userName,
Date from,
Date to,
boolean recentFirst)
throws RegistryException
resourcePath - If given, only the logs related to the resource path will be returned. If
null, logs for all resources will be returned.action - Only the logs pertaining to this action will be returned. For acceptable
values, see LogEntry.userName - If given, only the logs for activities done by the given user will be
returned. If null, logs for all users will be returned.from - If given, logs for activities occurred after the given date will be
returned. If null, there will not be a bound for the starting date.to - If given, logs for activities occurred before the given date will be
returned. If null, there will not be a bound for the ending date.recentFirst - If true, returned activities will be most-recent first. If false,
returned activities will be oldest first.
RegistryException - if there is a problemAccepted values for action parameterString[] getAvailableAspects()
void associateAspect(String resourcePath,
String aspect)
throws RegistryException
resourcePath - Path of the resourceaspect - Name of the aspect
RegistryException - If some thing went wrong while doing associating the phase
void invokeAspect(String resourcePath,
String aspectName,
String action)
throws RegistryException
resourcePath - Path of the resourceaspectName - Name of the aspectaction - Which action was selected - actions are aspect-specific
RegistryException - if the Aspect isn't associated with the Resource, or the action
isn't valid, or an Aspect-specific problem occurs.
String[] getAspectActions(String resourcePath,
String aspectName)
throws RegistryException
resourcePath - path of the ResourceaspectName - name of the Aspect to query for available actions
RegistryException - if the Aspect isn't associated or an Aspect-specific problem
occurs
void beginTransaction()
throws RegistryException
RegistryException - If an error occurs while starting a transaction
void commitTransaction()
throws RegistryException
RegistryException - If an error occurs while committing a transaction
void rollbackTransaction()
throws RegistryException
RegistryException - If an error occurs while rolling back a transactionRegistryContext getRegistryContext()
Collection searchContent(String keywords)
throws RegistryException
keywords - keywords to look for
RegistryException - throws if the operation fail
void createLink(String path,
String target)
throws RegistryException
path - the mount pathtarget - the point to be mounted
RegistryException - throws if the operation fail
void createLink(String path,
String target,
String subTargetPath)
throws RegistryException
path - the mount pathtarget - the point to be mountedsubTargetPath - sub path in the remote instance to be mounted
RegistryException - throws if the operation fail
void removeLink(String path)
throws RegistryException
path - the mount path
RegistryException - throws if the operation fail
void restore(String path,
Reader reader)
throws RegistryException
path - path to check inreader - reader containing resource
RegistryException - throws if the operation fail
void dump(String path,
Writer writer)
throws RegistryException
path - path to check outwriter - writer to write the response
RegistryException - throws if the operation fail
String getEventingServiceURL(String path)
throws RegistryException
path - the path to which the WS-Eventing Service URL is required
RegistryException - throws if the operation fail
void setEventingServiceURL(String path,
String eventingServiceURL)
throws RegistryException
path - the path to which the WS-Eventing Service URL is associatedeventingServiceURL - the URL of the WS-Eventing Service
RegistryException - throws if the operation fail
boolean removeAspect(String aspect)
throws RegistryException
aspect - the name of the aspect to be removed
RegistryException - throws if the operation fail
boolean addAspect(String name,
Aspect aspect)
throws RegistryException
name - the name of the aspect to be addedaspect - the name of the aspect object to be added to registry context
RegistryException - throws if the operation fail
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||